package capctx

import "github.com/cilium/ebpf/asm"

// Code generated by 'go run cmd/gen/helper_inst_gen.go | gofmt > cmd/capctx/helper_inst_gen.go' DO NOT EDIT

type helperFunc struct {
	retType string
	params  []helperParam
}

type helperParam struct {
	typ  string
	name string
}

var helpers = map[asm.BuiltinFunc]helperFunc{
	asm.FnMapLookupElem: {
		retType: "void *",
		params: []helperParam{
			{typ: "void *", name: "map"},
			{typ: "const void *", name: "key"},
		},
	},
	asm.FnMapUpdateElem: {
		retType: "long",
		params: []helperParam{
			{typ: "void *", name: "map"},
			{typ: "const void *", name: "key"},
			{typ: "const void *", name: "value"},
			{typ: "__u64", name: "flags"},
		},
	},
	asm.FnMapDeleteElem: {
		retType: "long",
		params: []helperParam{
			{typ: "void *", name: "map"},
			{typ: "const void *", name: "key"},
		},
	},
	asm.FnProbeRead: {
		retType: "long",
		params: []helperParam{
			{typ: "void *", name: "dst"},
			{typ: "__u32", name: "size"},
			{typ: "const void *", name: "unsafe_ptr"},
		},
	},
	asm.FnKtimeGetNs: {
		retType: "__u64",
		params:  []helperParam{},
	},
	asm.FnTracePrintk: {
		retType: "long",
		params: []helperParam{
			{typ: "const char *", name: "fmt"},
			{typ: "__u32", name: "fmt_size"},
			{typ: "...", name: ""},
		},
	},
	asm.FnGetPrandomU32: {
		retType: "__u32",
		params:  []helperParam{},
	},
	asm.FnGetSmpProcessorId: {
		retType: "__u32",
		params:  []helperParam{},
	},
	asm.FnSkbStoreBytes: {
		retType: "long",
		params: []helperParam{
			{typ: "struct __sk_buff *", name: "skb"},
			{typ: "__u32", name: "offset"},
			{typ: "const void *", name: "from"},
			{typ: "__u32", name: "len"},
			{typ: "__u64", name: "flags"},
		},
	},
	asm.FnL3CsumReplace: {
		retType: "long",
		params: []helperParam{
			{typ: "struct __sk_buff *", name: "skb"},
			{typ: "__u32", name: "offset"},
			{typ: "__u64", name: "from"},
			{typ: "__u64", name: "to"},
			{typ: "__u64", name: "size"},
		},
	},
	asm.FnL4CsumReplace: {
		retType: "long",
		params: []helperParam{
			{typ: "struct __sk_buff *", name: "skb"},
			{typ: "__u32", name: "offset"},
			{typ: "__u64", name: "from"},
			{typ: "__u64", name: "to"},
			{typ: "__u64", name: "flags"},
		},
	},
	asm.FnTailCall: {
		retType: "long",
		params: []helperParam{
			{typ: "void *", name: "ctx"},
			{typ: "void *", name: "prog_array_map"},
			{typ: "__u32", name: "index"},
		},
	},
	asm.FnCloneRedirect: {
		retType: "long",
		params: []helperParam{
			{typ: "struct __sk_buff *", name: "skb"},
			{typ: "__u32", name: "ifindex"},
			{typ: "__u64", name: "flags"},
		},
	},
	asm.FnGetCurrentPidTgid: {
		retType: "__u64",
		params:  []helperParam{},
	},
	asm.FnGetCurrentUidGid: {
		retType: "__u64",
		params:  []helperParam{},
	},
	asm.FnGetCurrentComm: {
		retType: "long",
		params: []helperParam{
			{typ: "void *", name: "buf"},
			{typ: "__u32", name: "size_of_buf"},
		},
	},
	asm.FnGetCgroupClassid: {
		retType: "__u32",
		params: []helperParam{
			{typ: "struct __sk_buff *", name: "skb"},
		},
	},
	asm.FnSkbVlanPush: {
		retType: "long",
		params: []helperParam{
			{typ: "struct __sk_buff *", name: "skb"},
			{typ: "__be16", name: "vlan_proto"},
			{typ: "__u16", name: "vlan_tci"},
		},
	},
	asm.FnSkbVlanPop: {
		retType: "long",
		params: []helperParam{
			{typ: "struct __sk_buff *", name: "skb"},
		},
	},
	asm.FnSkbGetTunnelKey: {
		retType: "long",
		params: []helperParam{
			{typ: "struct __sk_buff *", name: "skb"},
			{typ: "struct bpf_tunnel_key *", name: "key"},
			{typ: "__u32", name: "size"},
			{typ: "__u64", name: "flags"},
		},
	},
	asm.FnSkbSetTunnelKey: {
		retType: "long",
		params: []helperParam{
			{typ: "struct __sk_buff *", name: "skb"},
			{typ: "struct bpf_tunnel_key *", name: "key"},
			{typ: "__u32", name: "size"},
			{typ: "__u64", name: "flags"},
		},
	},
	asm.FnPerfEventRead: {
		retType: "__u64",
		params: []helperParam{
			{typ: "void *", name: "map"},
			{typ: "__u64", name: "flags"},
		},
	},
	asm.FnRedirect: {
		retType: "long",
		params: []helperParam{
			{typ: "__u32", name: "ifindex"},
			{typ: "__u64", name: "flags"},
		},
	},
	asm.FnGetRouteRealm: {
		retType: "__u32",
		params: []helperParam{
			{typ: "struct __sk_buff *", name: "skb"},
		},
	},
	asm.FnPerfEventOutput: {
		retType: "long",
		params: []helperParam{
			{typ: "void *", name: "ctx"},
			{typ: "void *", name: "map"},
			{typ: "__u64", name: "flags"},
			{typ: "void *", name: "data"},
			{typ: "__u64", name: "size"},
		},
	},
	asm.FnSkbLoadBytes: {
		retType: "long",
		params: []helperParam{
			{typ: "const void *", name: "skb"},
			{typ: "__u32", name: "offset"},
			{typ: "void *", name: "to"},
			{typ: "__u32", name: "len"},
		},
	},
	asm.FnGetStackid: {
		retType: "long",
		params: []helperParam{
			{typ: "void *", name: "ctx"},
			{typ: "void *", name: "map"},
			{typ: "__u64", name: "flags"},
		},
	},
	asm.FnCsumDiff: {
		retType: "__s64",
		params: []helperParam{
			{typ: "__be32 *", name: "from"},
			{typ: "__u32", name: "from_size"},
			{typ: "__be32 *", name: "to"},
			{typ: "__u32", name: "to_size"},
			{typ: "__wsum", name: "seed"},
		},
	},
	asm.FnSkbGetTunnelOpt: {
		retType: "long",
		params: []helperParam{
			{typ: "struct __sk_buff *", name: "skb"},
			{typ: "void *", name: "opt"},
			{typ: "__u32", name: "size"},
		},
	},
	asm.FnSkbSetTunnelOpt: {
		retType: "long",
		params: []helperParam{
			{typ: "struct __sk_buff *", name: "skb"},
			{typ: "void *", name: "opt"},
			{typ: "__u32", name: "size"},
		},
	},
	asm.FnSkbChangeProto: {
		retType: "long",
		params: []helperParam{
			{typ: "struct __sk_buff *", name: "skb"},
			{typ: "__be16", name: "proto"},
			{typ: "__u64", name: "flags"},
		},
	},
	asm.FnSkbChangeType: {
		retType: "long",
		params: []helperParam{
			{typ: "struct __sk_buff *", name: "skb"},
			{typ: "__u32", name: "type"},
		},
	},
	asm.FnSkbUnderCgroup: {
		retType: "long",
		params: []helperParam{
			{typ: "struct __sk_buff *", name: "skb"},
			{typ: "void *", name: "map"},
			{typ: "__u32", name: "index"},
		},
	},
	asm.FnGetHashRecalc: {
		retType: "__u32",
		params: []helperParam{
			{typ: "struct __sk_buff *", name: "skb"},
		},
	},
	asm.FnGetCurrentTask: {
		retType: "__u64",
		params:  []helperParam{},
	},
	asm.FnProbeWriteUser: {
		retType: "long",
		params: []helperParam{
			{typ: "void *", name: "dst"},
			{typ: "const void *", name: "src"},
			{typ: "__u32", name: "len"},
		},
	},
	asm.FnCurrentTaskUnderCgroup: {
		retType: "long",
		params: []helperParam{
			{typ: "void *", name: "map"},
			{typ: "__u32", name: "index"},
		},
	},
	asm.FnSkbChangeTail: {
		retType: "long",
		params: []helperParam{
			{typ: "struct __sk_buff *", name: "skb"},
			{typ: "__u32", name: "len"},
			{typ: "__u64", name: "flags"},
		},
	},
	asm.FnSkbPullData: {
		retType: "long",
		params: []helperParam{
			{typ: "struct __sk_buff *", name: "skb"},
			{typ: "__u32", name: "len"},
		},
	},
	asm.FnCsumUpdate: {
		retType: "__s64",
		params: []helperParam{
			{typ: "struct __sk_buff *", name: "skb"},
			{typ: "__wsum", name: "csum"},
		},
	},
	asm.FnSetHashInvalid: {
		retType: "void",
		params: []helperParam{
			{typ: "struct __sk_buff *", name: "skb"},
		},
	},
	asm.FnGetNumaNodeId: {
		retType: "long",
		params:  []helperParam{},
	},
	asm.FnSkbChangeHead: {
		retType: "long",
		params: []helperParam{
			{typ: "struct __sk_buff *", name: "skb"},
			{typ: "__u32", name: "len"},
			{typ: "__u64", name: "flags"},
		},
	},
	asm.FnXdpAdjustHead: {
		retType: "long",
		params: []helperParam{
			{typ: "struct xdp_md *", name: "xdp_md"},
			{typ: "int", name: "delta"},
		},
	},
	asm.FnProbeReadStr: {
		retType: "long",
		params: []helperParam{
			{typ: "void *", name: "dst"},
			{typ: "__u32", name: "size"},
			{typ: "const void *", name: "unsafe_ptr"},
		},
	},
	asm.FnGetSocketCookie: {
		retType: "__u64",
		params: []helperParam{
			{typ: "void *", name: "ctx"},
		},
	},
	asm.FnGetSocketUid: {
		retType: "__u32",
		params: []helperParam{
			{typ: "struct __sk_buff *", name: "skb"},
		},
	},
	asm.FnSetHash: {
		retType: "long",
		params: []helperParam{
			{typ: "struct __sk_buff *", name: "skb"},
			{typ: "__u32", name: "hash"},
		},
	},
	asm.FnSetsockopt: {
		retType: "long",
		params: []helperParam{
			{typ: "void *", name: "bpf_socket"},
			{typ: "int", name: "level"},
			{typ: "int", name: "optname"},
			{typ: "void *", name: "optval"},
			{typ: "int", name: "optlen"},
		},
	},
	asm.FnSkbAdjustRoom: {
		retType: "long",
		params: []helperParam{
			{typ: "struct __sk_buff *", name: "skb"},
			{typ: "__s32", name: "len_diff"},
			{typ: "__u32", name: "mode"},
			{typ: "__u64", name: "flags"},
		},
	},
	asm.FnRedirectMap: {
		retType: "long",
		params: []helperParam{
			{typ: "void *", name: "map"},
			{typ: "__u32", name: "key"},
			{typ: "__u64", name: "flags"},
		},
	},
	asm.FnSkRedirectMap: {
		retType: "long",
		params: []helperParam{
			{typ: "struct __sk_buff *", name: "skb"},
			{typ: "void *", name: "map"},
			{typ: "__u32", name: "key"},
			{typ: "__u64", name: "flags"},
		},
	},
	asm.FnSockMapUpdate: {
		retType: "long",
		params: []helperParam{
			{typ: "struct bpf_sock_ops *", name: "skops"},
			{typ: "void *", name: "map"},
			{typ: "void *", name: "key"},
			{typ: "__u64", name: "flags"},
		},
	},
	asm.FnXdpAdjustMeta: {
		retType: "long",
		params: []helperParam{
			{typ: "struct xdp_md *", name: "xdp_md"},
			{typ: "int", name: "delta"},
		},
	},
	asm.FnPerfEventReadValue: {
		retType: "long",
		params: []helperParam{
			{typ: "void *", name: "map"},
			{typ: "__u64", name: "flags"},
			{typ: "struct bpf_perf_event_value *", name: "buf"},
			{typ: "__u32", name: "buf_size"},
		},
	},
	asm.FnPerfProgReadValue: {
		retType: "long",
		params: []helperParam{
			{typ: "struct bpf_perf_event_data *", name: "ctx"},
			{typ: "struct bpf_perf_event_value *", name: "buf"},
			{typ: "__u32", name: "buf_size"},
		},
	},
	asm.FnGetsockopt: {
		retType: "long",
		params: []helperParam{
			{typ: "void *", name: "bpf_socket"},
			{typ: "int", name: "level"},
			{typ: "int", name: "optname"},
			{typ: "void *", name: "optval"},
			{typ: "int", name: "optlen"},
		},
	},
	asm.FnOverrideReturn: {
		retType: "long",
		params: []helperParam{
			{typ: "struct pt_regs *", name: "regs"},
			{typ: "__u64", name: "rc"},
		},
	},
	asm.FnSockOpsCbFlagsSet: {
		retType: "long",
		params: []helperParam{
			{typ: "struct bpf_sock_ops *", name: "bpf_sock"},
			{typ: "int", name: "argval"},
		},
	},
	asm.FnMsgRedirectMap: {
		retType: "long",
		params: []helperParam{
			{typ: "struct sk_msg_md *", name: "msg"},
			{typ: "void *", name: "map"},
			{typ: "__u32", name: "key"},
			{typ: "__u64", name: "flags"},
		},
	},
	asm.FnMsgApplyBytes: {
		retType: "long",
		params: []helperParam{
			{typ: "struct sk_msg_md *", name: "msg"},
			{typ: "__u32", name: "bytes"},
		},
	},
	asm.FnMsgCorkBytes: {
		retType: "long",
		params: []helperParam{
			{typ: "struct sk_msg_md *", name: "msg"},
			{typ: "__u32", name: "bytes"},
		},
	},
	asm.FnMsgPullData: {
		retType: "long",
		params: []helperParam{
			{typ: "struct sk_msg_md *", name: "msg"},
			{typ: "__u32", name: "start"},
			{typ: "__u32", name: "end"},
			{typ: "__u64", name: "flags"},
		},
	},
	asm.FnBind: {
		retType: "long",
		params: []helperParam{
			{typ: "struct bpf_sock_addr *", name: "ctx"},
			{typ: "struct sockaddr *", name: "addr"},
			{typ: "int", name: "addr_len"},
		},
	},
	asm.FnXdpAdjustTail: {
		retType: "long",
		params: []helperParam{
			{typ: "struct xdp_md *", name: "xdp_md"},
			{typ: "int", name: "delta"},
		},
	},
	asm.FnSkbGetXfrmState: {
		retType: "long",
		params: []helperParam{
			{typ: "struct __sk_buff *", name: "skb"},
			{typ: "__u32", name: "index"},
			{typ: "struct bpf_xfrm_state *", name: "xfrm_state"},
			{typ: "__u32", name: "size"},
			{typ: "__u64", name: "flags"},
		},
	},
	asm.FnGetStack: {
		retType: "long",
		params: []helperParam{
			{typ: "void *", name: "ctx"},
			{typ: "void *", name: "buf"},
			{typ: "__u32", name: "size"},
			{typ: "__u64", name: "flags"},
		},
	},
	asm.FnSkbLoadBytesRelative: {
		retType: "long",
		params: []helperParam{
			{typ: "const void *", name: "skb"},
			{typ: "__u32", name: "offset"},
			{typ: "void *", name: "to"},
			{typ: "__u32", name: "len"},
			{typ: "__u32", name: "start_header"},
		},
	},
	asm.FnFibLookup: {
		retType: "long",
		params: []helperParam{
			{typ: "void *", name: "ctx"},
			{typ: "struct bpf_fib_lookup *", name: "params"},
			{typ: "int", name: "plen"},
			{typ: "__u32", name: "flags"},
		},
	},
	asm.FnSockHashUpdate: {
		retType: "long",
		params: []helperParam{
			{typ: "struct bpf_sock_ops *", name: "skops"},
			{typ: "void *", name: "map"},
			{typ: "void *", name: "key"},
			{typ: "__u64", name: "flags"},
		},
	},
	asm.FnMsgRedirectHash: {
		retType: "long",
		params: []helperParam{
			{typ: "struct sk_msg_md *", name: "msg"},
			{typ: "void *", name: "map"},
			{typ: "void *", name: "key"},
			{typ: "__u64", name: "flags"},
		},
	},
	asm.FnSkRedirectHash: {
		retType: "long",
		params: []helperParam{
			{typ: "struct __sk_buff *", name: "skb"},
			{typ: "void *", name: "map"},
			{typ: "void *", name: "key"},
			{typ: "__u64", name: "flags"},
		},
	},
	asm.FnLwtPushEncap: {
		retType: "long",
		params: []helperParam{
			{typ: "struct __sk_buff *", name: "skb"},
			{typ: "__u32", name: "type"},
			{typ: "void *", name: "hdr"},
			{typ: "__u32", name: "len"},
		},
	},
	asm.FnLwtSeg6StoreBytes: {
		retType: "long",
		params: []helperParam{
			{typ: "struct __sk_buff *", name: "skb"},
			{typ: "__u32", name: "offset"},
			{typ: "const void *", name: "from"},
			{typ: "__u32", name: "len"},
		},
	},
	asm.FnLwtSeg6AdjustSrh: {
		retType: "long",
		params: []helperParam{
			{typ: "struct __sk_buff *", name: "skb"},
			{typ: "__u32", name: "offset"},
			{typ: "__s32", name: "delta"},
		},
	},
	asm.FnLwtSeg6Action: {
		retType: "long",
		params: []helperParam{
			{typ: "struct __sk_buff *", name: "skb"},
			{typ: "__u32", name: "action"},
			{typ: "void *", name: "param"},
			{typ: "__u32", name: "param_len"},
		},
	},
	asm.FnRcRepeat: {
		retType: "long",
		params: []helperParam{
			{typ: "void *", name: "ctx"},
		},
	},
	asm.FnRcKeydown: {
		retType: "long",
		params: []helperParam{
			{typ: "void *", name: "ctx"},
			{typ: "__u32", name: "protocol"},
			{typ: "__u64", name: "scancode"},
			{typ: "__u32", name: "toggle"},
		},
	},
	asm.FnSkbCgroupId: {
		retType: "__u64",
		params: []helperParam{
			{typ: "struct __sk_buff *", name: "skb"},
		},
	},
	asm.FnGetCurrentCgroupId: {
		retType: "__u64",
		params:  []helperParam{},
	},
	asm.FnGetLocalStorage: {
		retType: "void *",
		params: []helperParam{
			{typ: "void *", name: "map"},
			{typ: "__u64", name: "flags"},
		},
	},
	asm.FnSkSelectReuseport: {
		retType: "long",
		params: []helperParam{
			{typ: "struct sk_reuseport_md *", name: "reuse"},
			{typ: "void *", name: "map"},
			{typ: "void *", name: "key"},
			{typ: "__u64", name: "flags"},
		},
	},
	asm.FnSkbAncestorCgroupId: {
		retType: "__u64",
		params: []helperParam{
			{typ: "struct __sk_buff *", name: "skb"},
			{typ: "int", name: "ancestor_level"},
		},
	},
	asm.FnSkLookupTcp: {
		retType: "struct bpf_sock *",
		params: []helperParam{
			{typ: "void *", name: "ctx"},
			{typ: "struct bpf_sock_tuple *", name: "tuple"},
			{typ: "__u32", name: "tuple_size"},
			{typ: "__u64", name: "netns"},
			{typ: "__u64", name: "flags"},
		},
	},
	asm.FnSkLookupUdp: {
		retType: "struct bpf_sock *",
		params: []helperParam{
			{typ: "void *", name: "ctx"},
			{typ: "struct bpf_sock_tuple *", name: "tuple"},
			{typ: "__u32", name: "tuple_size"},
			{typ: "__u64", name: "netns"},
			{typ: "__u64", name: "flags"},
		},
	},
	asm.FnSkRelease: {
		retType: "long",
		params: []helperParam{
			{typ: "void *", name: "sock"},
		},
	},
	asm.FnMapPushElem: {
		retType: "long",
		params: []helperParam{
			{typ: "void *", name: "map"},
			{typ: "const void *", name: "value"},
			{typ: "__u64", name: "flags"},
		},
	},
	asm.FnMapPopElem: {
		retType: "long",
		params: []helperParam{
			{typ: "void *", name: "map"},
			{typ: "void *", name: "value"},
		},
	},
	asm.FnMapPeekElem: {
		retType: "long",
		params: []helperParam{
			{typ: "void *", name: "map"},
			{typ: "void *", name: "value"},
		},
	},
	asm.FnMsgPushData: {
		retType: "long",
		params: []helperParam{
			{typ: "struct sk_msg_md *", name: "msg"},
			{typ: "__u32", name: "start"},
			{typ: "__u32", name: "len"},
			{typ: "__u64", name: "flags"},
		},
	},
	asm.FnMsgPopData: {
		retType: "long",
		params: []helperParam{
			{typ: "struct sk_msg_md *", name: "msg"},
			{typ: "__u32", name: "start"},
			{typ: "__u32", name: "len"},
			{typ: "__u64", name: "flags"},
		},
	},
	asm.FnRcPointerRel: {
		retType: "long",
		params: []helperParam{
			{typ: "void *", name: "ctx"},
			{typ: "__s32", name: "rel_x"},
			{typ: "__s32", name: "rel_y"},
		},
	},
	asm.FnSpinLock: {
		retType: "long",
		params: []helperParam{
			{typ: "struct bpf_spin_lock *", name: "lock"},
		},
	},
	asm.FnSpinUnlock: {
		retType: "long",
		params: []helperParam{
			{typ: "struct bpf_spin_lock *", name: "lock"},
		},
	},
	asm.FnSkFullsock: {
		retType: "struct bpf_sock *",
		params: []helperParam{
			{typ: "struct bpf_sock *", name: "sk"},
		},
	},
	asm.FnTcpSock: {
		retType: "struct bpf_tcp_sock *",
		params: []helperParam{
			{typ: "struct bpf_sock *", name: "sk"},
		},
	},
	asm.FnSkbEcnSetCe: {
		retType: "long",
		params: []helperParam{
			{typ: "struct __sk_buff *", name: "skb"},
		},
	},
	asm.FnGetListenerSock: {
		retType: "struct bpf_sock *",
		params: []helperParam{
			{typ: "struct bpf_sock *", name: "sk"},
		},
	},
	asm.FnSkcLookupTcp: {
		retType: "struct bpf_sock *",
		params: []helperParam{
			{typ: "void *", name: "ctx"},
			{typ: "struct bpf_sock_tuple *", name: "tuple"},
			{typ: "__u32", name: "tuple_size"},
			{typ: "__u64", name: "netns"},
			{typ: "__u64", name: "flags"},
		},
	},
	asm.FnTcpCheckSyncookie: {
		retType: "long",
		params: []helperParam{
			{typ: "void *", name: "sk"},
			{typ: "void *", name: "iph"},
			{typ: "__u32", name: "iph_len"},
			{typ: "struct tcphdr *", name: "th"},
			{typ: "__u32", name: "th_len"},
		},
	},
	asm.FnSysctlGetName: {
		retType: "long",
		params: []helperParam{
			{typ: "struct bpf_sysctl *", name: "ctx"},
			{typ: "char *", name: "buf"},
			{typ: "unsigned long", name: "buf_len"},
			{typ: "__u64", name: "flags"},
		},
	},
	asm.FnSysctlGetCurrentValue: {
		retType: "long",
		params: []helperParam{
			{typ: "struct bpf_sysctl *", name: "ctx"},
			{typ: "char *", name: "buf"},
			{typ: "unsigned long", name: "buf_len"},
		},
	},
	asm.FnSysctlGetNewValue: {
		retType: "long",
		params: []helperParam{
			{typ: "struct bpf_sysctl *", name: "ctx"},
			{typ: "char *", name: "buf"},
			{typ: "unsigned long", name: "buf_len"},
		},
	},
	asm.FnSysctlSetNewValue: {
		retType: "long",
		params: []helperParam{
			{typ: "struct bpf_sysctl *", name: "ctx"},
			{typ: "const char *", name: "buf"},
			{typ: "unsigned long", name: "buf_len"},
		},
	},
	asm.FnStrtol: {
		retType: "long",
		params: []helperParam{
			{typ: "const char *", name: "buf"},
			{typ: "unsigned long", name: "buf_len"},
			{typ: "__u64", name: "flags"},
			{typ: "long *", name: "res"},
		},
	},
	asm.FnStrtoul: {
		retType: "long",
		params: []helperParam{
			{typ: "const char *", name: "buf"},
			{typ: "unsigned long", name: "buf_len"},
			{typ: "__u64", name: "flags"},
			{typ: "unsigned long *", name: "res"},
		},
	},
	asm.FnSkStorageGet: {
		retType: "void *",
		params: []helperParam{
			{typ: "void *", name: "map"},
			{typ: "void *", name: "sk"},
			{typ: "void *", name: "value"},
			{typ: "__u64", name: "flags"},
		},
	},
	asm.FnSkStorageDelete: {
		retType: "long",
		params: []helperParam{
			{typ: "void *", name: "map"},
			{typ: "void *", name: "sk"},
		},
	},
	asm.FnSendSignal: {
		retType: "long",
		params: []helperParam{
			{typ: "__u32", name: "sig"},
		},
	},
	asm.FnTcpGenSyncookie: {
		retType: "__s64",
		params: []helperParam{
			{typ: "void *", name: "sk"},
			{typ: "void *", name: "iph"},
			{typ: "__u32", name: "iph_len"},
			{typ: "struct tcphdr *", name: "th"},
			{typ: "__u32", name: "th_len"},
		},
	},
	asm.FnSkbOutput: {
		retType: "long",
		params: []helperParam{
			{typ: "void *", name: "ctx"},
			{typ: "void *", name: "map"},
			{typ: "__u64", name: "flags"},
			{typ: "void *", name: "data"},
			{typ: "__u64", name: "size"},
		},
	},
	asm.FnProbeReadUser: {
		retType: "long",
		params: []helperParam{
			{typ: "void *", name: "dst"},
			{typ: "__u32", name: "size"},
			{typ: "const void *", name: "unsafe_ptr"},
		},
	},
	asm.FnProbeReadKernel: {
		retType: "long",
		params: []helperParam{
			{typ: "void *", name: "dst"},
			{typ: "__u32", name: "size"},
			{typ: "const void *", name: "unsafe_ptr"},
		},
	},
	asm.FnProbeReadUserStr: {
		retType: "long",
		params: []helperParam{
			{typ: "void *", name: "dst"},
			{typ: "__u32", name: "size"},
			{typ: "const void *", name: "unsafe_ptr"},
		},
	},
	asm.FnProbeReadKernelStr: {
		retType: "long",
		params: []helperParam{
			{typ: "void *", name: "dst"},
			{typ: "__u32", name: "size"},
			{typ: "const void *", name: "unsafe_ptr"},
		},
	},
	asm.FnTcpSendAck: {
		retType: "long",
		params: []helperParam{
			{typ: "void *", name: "tp"},
			{typ: "__u32", name: "rcv_nxt"},
		},
	},
	asm.FnSendSignalThread: {
		retType: "long",
		params: []helperParam{
			{typ: "__u32", name: "sig"},
		},
	},
	asm.FnJiffies64: {
		retType: "__u64",
		params:  []helperParam{},
	},
	asm.FnReadBranchRecords: {
		retType: "long",
		params: []helperParam{
			{typ: "struct bpf_perf_event_data *", name: "ctx"},
			{typ: "void *", name: "buf"},
			{typ: "__u32", name: "size"},
			{typ: "__u64", name: "flags"},
		},
	},
	asm.FnGetNsCurrentPidTgid: {
		retType: "long",
		params: []helperParam{
			{typ: "__u64", name: "dev"},
			{typ: "__u64", name: "ino"},
			{typ: "struct bpf_pidns_info *", name: "nsdata"},
			{typ: "__u32", name: "size"},
		},
	},
	asm.FnXdpOutput: {
		retType: "long",
		params: []helperParam{
			{typ: "void *", name: "ctx"},
			{typ: "void *", name: "map"},
			{typ: "__u64", name: "flags"},
			{typ: "void *", name: "data"},
			{typ: "__u64", name: "size"},
		},
	},
	asm.FnGetNetnsCookie: {
		retType: "__u64",
		params: []helperParam{
			{typ: "void *", name: "ctx"},
		},
	},
	asm.FnGetCurrentAncestorCgroupId: {
		retType: "__u64",
		params: []helperParam{
			{typ: "int", name: "ancestor_level"},
		},
	},
	asm.FnSkAssign: {
		retType: "long",
		params: []helperParam{
			{typ: "void *", name: "ctx"},
			{typ: "void *", name: "sk"},
			{typ: "__u64", name: "flags"},
		},
	},
	asm.FnKtimeGetBootNs: {
		retType: "__u64",
		params:  []helperParam{},
	},
	asm.FnSeqPrintf: {
		retType: "long",
		params: []helperParam{
			{typ: "struct seq_file *", name: "m"},
			{typ: "const char *", name: "fmt"},
			{typ: "__u32", name: "fmt_size"},
			{typ: "const void *", name: "data"},
			{typ: "__u32", name: "data_len"},
		},
	},
	asm.FnSeqWrite: {
		retType: "long",
		params: []helperParam{
			{typ: "struct seq_file *", name: "m"},
			{typ: "const void *", name: "data"},
			{typ: "__u32", name: "len"},
		},
	},
	asm.FnSkCgroupId: {
		retType: "__u64",
		params: []helperParam{
			{typ: "void *", name: "sk"},
		},
	},
	asm.FnSkAncestorCgroupId: {
		retType: "__u64",
		params: []helperParam{
			{typ: "void *", name: "sk"},
			{typ: "int", name: "ancestor_level"},
		},
	},
	asm.FnRingbufOutput: {
		retType: "long",
		params: []helperParam{
			{typ: "void *", name: "ringbuf"},
			{typ: "void *", name: "data"},
			{typ: "__u64", name: "size"},
			{typ: "__u64", name: "flags"},
		},
	},
	asm.FnRingbufReserve: {
		retType: "void *",
		params: []helperParam{
			{typ: "void *", name: "ringbuf"},
			{typ: "__u64", name: "size"},
			{typ: "__u64", name: "flags"},
		},
	},
	asm.FnRingbufSubmit: {
		retType: "void",
		params: []helperParam{
			{typ: "void *", name: "data"},
			{typ: "__u64", name: "flags"},
		},
	},
	asm.FnRingbufDiscard: {
		retType: "void",
		params: []helperParam{
			{typ: "void *", name: "data"},
			{typ: "__u64", name: "flags"},
		},
	},
	asm.FnRingbufQuery: {
		retType: "__u64",
		params: []helperParam{
			{typ: "void *", name: "ringbuf"},
			{typ: "__u64", name: "flags"},
		},
	},
	asm.FnCsumLevel: {
		retType: "long",
		params: []helperParam{
			{typ: "struct __sk_buff *", name: "skb"},
			{typ: "__u64", name: "level"},
		},
	},
	asm.FnSkcToTcp6Sock: {
		retType: "struct tcp6_sock *",
		params: []helperParam{
			{typ: "void *", name: "sk"},
		},
	},
	asm.FnSkcToTcpSock: {
		retType: "struct tcp_sock *",
		params: []helperParam{
			{typ: "void *", name: "sk"},
		},
	},
	asm.FnSkcToTcpTimewaitSock: {
		retType: "struct tcp_timewait_sock *",
		params: []helperParam{
			{typ: "void *", name: "sk"},
		},
	},
	asm.FnSkcToTcpRequestSock: {
		retType: "struct tcp_request_sock *",
		params: []helperParam{
			{typ: "void *", name: "sk"},
		},
	},
	asm.FnSkcToUdp6Sock: {
		retType: "struct udp6_sock *",
		params: []helperParam{
			{typ: "void *", name: "sk"},
		},
	},
	asm.FnGetTaskStack: {
		retType: "long",
		params: []helperParam{
			{typ: "struct task_struct *", name: "task"},
			{typ: "void *", name: "buf"},
			{typ: "__u32", name: "size"},
			{typ: "__u64", name: "flags"},
		},
	},
	asm.FnLoadHdrOpt: {
		retType: "long",
		params: []helperParam{
			{typ: "struct bpf_sock_ops *", name: "skops"},
			{typ: "void *", name: "searchby_res"},
			{typ: "__u32", name: "len"},
			{typ: "__u64", name: "flags"},
		},
	},
	asm.FnStoreHdrOpt: {
		retType: "long",
		params: []helperParam{
			{typ: "struct bpf_sock_ops *", name: "skops"},
			{typ: "const void *", name: "from"},
			{typ: "__u32", name: "len"},
			{typ: "__u64", name: "flags"},
		},
	},
	asm.FnReserveHdrOpt: {
		retType: "long",
		params: []helperParam{
			{typ: "struct bpf_sock_ops *", name: "skops"},
			{typ: "__u32", name: "len"},
			{typ: "__u64", name: "flags"},
		},
	},
	asm.FnInodeStorageGet: {
		retType: "void *",
		params: []helperParam{
			{typ: "void *", name: "map"},
			{typ: "void *", name: "inode"},
			{typ: "void *", name: "value"},
			{typ: "__u64", name: "flags"},
		},
	},
	asm.FnInodeStorageDelete: {
		retType: "int",
		params: []helperParam{
			{typ: "void *", name: "map"},
			{typ: "void *", name: "inode"},
		},
	},
	asm.FnDPath: {
		retType: "long",
		params: []helperParam{
			{typ: "struct path *", name: "path"},
			{typ: "char *", name: "buf"},
			{typ: "__u32", name: "sz"},
		},
	},
	asm.FnCopyFromUser: {
		retType: "long",
		params: []helperParam{
			{typ: "void *", name: "dst"},
			{typ: "__u32", name: "size"},
			{typ: "const void *", name: "user_ptr"},
		},
	},
	asm.FnSnprintfBtf: {
		retType: "long",
		params: []helperParam{
			{typ: "char *", name: "str"},
			{typ: "__u32", name: "str_size"},
			{typ: "struct btf_ptr *", name: "ptr"},
			{typ: "__u32", name: "btf_ptr_size"},
			{typ: "__u64", name: "flags"},
		},
	},
	asm.FnSeqPrintfBtf: {
		retType: "long",
		params: []helperParam{
			{typ: "struct seq_file *", name: "m"},
			{typ: "struct btf_ptr *", name: "ptr"},
			{typ: "__u32", name: "ptr_size"},
			{typ: "__u64", name: "flags"},
		},
	},
	asm.FnSkbCgroupClassid: {
		retType: "__u64",
		params: []helperParam{
			{typ: "struct __sk_buff *", name: "skb"},
		},
	},
	asm.FnRedirectNeigh: {
		retType: "long",
		params: []helperParam{
			{typ: "__u32", name: "ifindex"},
			{typ: "struct bpf_redir_neigh *", name: "params"},
			{typ: "int", name: "plen"},
			{typ: "__u64", name: "flags"},
		},
	},
	asm.FnPerCpuPtr: {
		retType: "void *",
		params: []helperParam{
			{typ: "const void *", name: "percpu_ptr"},
			{typ: "__u32", name: "cpu"},
		},
	},
	asm.FnThisCpuPtr: {
		retType: "void *",
		params: []helperParam{
			{typ: "const void *", name: "percpu_ptr"},
		},
	},
	asm.FnRedirectPeer: {
		retType: "long",
		params: []helperParam{
			{typ: "__u32", name: "ifindex"},
			{typ: "__u64", name: "flags"},
		},
	},
	asm.FnTaskStorageGet: {
		retType: "void *",
		params: []helperParam{
			{typ: "void *", name: "map"},
			{typ: "struct task_struct *", name: "task"},
			{typ: "void *", name: "value"},
			{typ: "__u64", name: "flags"},
		},
	},
	asm.FnTaskStorageDelete: {
		retType: "long",
		params: []helperParam{
			{typ: "void *", name: "map"},
			{typ: "struct task_struct *", name: "task"},
		},
	},
	asm.FnGetCurrentTaskBtf: {
		retType: "struct task_struct *",
		params:  []helperParam{},
	},
	asm.FnBprmOptsSet: {
		retType: "long",
		params: []helperParam{
			{typ: "struct linux_binprm *", name: "bprm"},
			{typ: "__u64", name: "flags"},
		},
	},
	asm.FnKtimeGetCoarseNs: {
		retType: "__u64",
		params:  []helperParam{},
	},
	asm.FnImaInodeHash: {
		retType: "long",
		params: []helperParam{
			{typ: "struct inode *", name: "inode"},
			{typ: "void *", name: "dst"},
			{typ: "__u32", name: "size"},
		},
	},
	asm.FnSockFromFile: {
		retType: "struct socket *",
		params: []helperParam{
			{typ: "struct file *", name: "file"},
		},
	},
	asm.FnCheckMtu: {
		retType: "long",
		params: []helperParam{
			{typ: "void *", name: "ctx"},
			{typ: "__u32", name: "ifindex"},
			{typ: "__u32 *", name: "mtu_len"},
			{typ: "__s32", name: "len_diff"},
			{typ: "__u64", name: "flags"},
		},
	},
	asm.FnForEachMapElem: {
		retType: "long",
		params: []helperParam{
			{typ: "void *", name: "map"},
			{typ: "void *", name: "callback_fn"},
			{typ: "void *", name: "callback_ctx"},
			{typ: "__u64", name: "flags"},
		},
	},
	asm.FnSnprintf: {
		retType: "long",
		params: []helperParam{
			{typ: "char *", name: "str"},
			{typ: "__u32", name: "str_size"},
			{typ: "const char *", name: "fmt"},
			{typ: "__u64 *", name: "data"},
			{typ: "__u32", name: "data_len"},
		},
	},
	asm.FnSysBpf: {
		retType: "long",
		params: []helperParam{
			{typ: "__u32", name: "cmd"},
			{typ: "void *", name: "attr"},
			{typ: "__u32", name: "attr_size"},
		},
	},
	asm.FnBtfFindByNameKind: {
		retType: "long",
		params: []helperParam{
			{typ: "char *", name: "name"},
			{typ: "int", name: "name_sz"},
			{typ: "__u32", name: "kind"},
			{typ: "int", name: "flags"},
		},
	},
	asm.FnSysClose: {
		retType: "long",
		params: []helperParam{
			{typ: "__u32", name: "fd"},
		},
	},
	asm.FnTimerInit: {
		retType: "long",
		params: []helperParam{
			{typ: "struct bpf_timer *", name: "timer"},
			{typ: "void *", name: "map"},
			{typ: "__u64", name: "flags"},
		},
	},
	asm.FnTimerSetCallback: {
		retType: "long",
		params: []helperParam{
			{typ: "struct bpf_timer *", name: "timer"},
			{typ: "void *", name: "callback_fn"},
		},
	},
	asm.FnTimerStart: {
		retType: "long",
		params: []helperParam{
			{typ: "struct bpf_timer *", name: "timer"},
			{typ: "__u64", name: "nsecs"},
			{typ: "__u64", name: "flags"},
		},
	},
	asm.FnTimerCancel: {
		retType: "long",
		params: []helperParam{
			{typ: "struct bpf_timer *", name: "timer"},
		},
	},
	asm.FnGetFuncIp: {
		retType: "__u64",
		params: []helperParam{
			{typ: "void *", name: "ctx"},
		},
	},
	asm.FnGetAttachCookie: {
		retType: "__u64",
		params: []helperParam{
			{typ: "void *", name: "ctx"},
		},
	},
	asm.FnTaskPtRegs: {
		retType: "long",
		params: []helperParam{
			{typ: "struct task_struct *", name: "task"},
		},
	},
	asm.BuiltinFunc(176): {
		retType: "long",
		params: []helperParam{
			{typ: "void *", name: "entries"},
			{typ: "__u32", name: "size"},
			{typ: "__u64", name: "flags"},
		},
	},
	asm.BuiltinFunc(177): {
		retType: "long",
		params: []helperParam{
			{typ: "const char *", name: "fmt"},
			{typ: "__u32", name: "fmt_size"},
			{typ: "const void *", name: "data"},
			{typ: "__u32", name: "data_len"},
		},
	},
	asm.BuiltinFunc(178): {
		retType: "struct unix_sock *",
		params: []helperParam{
			{typ: "void *", name: "sk"},
		},
	},
	asm.BuiltinFunc(179): {
		retType: "long",
		params: []helperParam{
			{typ: "const char *", name: "name"},
			{typ: "int", name: "name_sz"},
			{typ: "int", name: "flags"},
			{typ: "__u64 *", name: "res"},
		},
	},
	asm.BuiltinFunc(180): {
		retType: "long",
		params: []helperParam{
			{typ: "struct task_struct *", name: "task"},
			{typ: "__u64", name: "addr"},
			{typ: "void *", name: "callback_fn"},
			{typ: "void *", name: "callback_ctx"},
			{typ: "__u64", name: "flags"},
		},
	},
	asm.BuiltinFunc(181): {
		retType: "long",
		params: []helperParam{
			{typ: "__u32", name: "nr_loops"},
			{typ: "void *", name: "callback_fn"},
			{typ: "void *", name: "callback_ctx"},
			{typ: "__u64", name: "flags"},
		},
	},
	asm.BuiltinFunc(182): {
		retType: "long",
		params: []helperParam{
			{typ: "const char *", name: "s1"},
			{typ: "__u32", name: "s1_sz"},
			{typ: "const char *", name: "s2"},
		},
	},
	asm.BuiltinFunc(183): {
		retType: "long",
		params: []helperParam{
			{typ: "void *", name: "ctx"},
			{typ: "__u32", name: "n"},
			{typ: "__u64 *", name: "value"},
		},
	},
	asm.BuiltinFunc(184): {
		retType: "long",
		params: []helperParam{
			{typ: "void *", name: "ctx"},
			{typ: "__u64 *", name: "value"},
		},
	},
	asm.BuiltinFunc(185): {
		retType: "long",
		params: []helperParam{
			{typ: "void *", name: "ctx"},
		},
	},
	asm.BuiltinFunc(186): {
		retType: "int",
		params:  []helperParam{},
	},
	asm.BuiltinFunc(187): {
		retType: "int",
		params: []helperParam{
			{typ: "int", name: "retval"},
		},
	},
	asm.BuiltinFunc(188): {
		retType: "__u64",
		params: []helperParam{
			{typ: "struct xdp_md *", name: "xdp_md"},
		},
	},
	asm.BuiltinFunc(189): {
		retType: "long",
		params: []helperParam{
			{typ: "struct xdp_md *", name: "xdp_md"},
			{typ: "__u32", name: "offset"},
			{typ: "void *", name: "buf"},
			{typ: "__u32", name: "len"},
		},
	},
	asm.BuiltinFunc(190): {
		retType: "long",
		params: []helperParam{
			{typ: "struct xdp_md *", name: "xdp_md"},
			{typ: "__u32", name: "offset"},
			{typ: "void *", name: "buf"},
			{typ: "__u32", name: "len"},
		},
	},
	asm.BuiltinFunc(191): {
		retType: "long",
		params: []helperParam{
			{typ: "void *", name: "dst"},
			{typ: "__u32", name: "size"},
			{typ: "const void *", name: "user_ptr"},
			{typ: "struct task_struct *", name: "tsk"},
			{typ: "__u64", name: "flags"},
		},
	},
}
